#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <libirc.h>
#include <getopt.h>
#include <sys/types.h>
#include <time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
struct skin{
    char nick[12], user[12], realname[50];
};
struct mucca_opt{
    char *server, *skin;
    int v6, port;
};
struct fields{
    char name[100];
    char value[100];
};

void get_pass(char *skindir, char *pass){
	FILE *fd;
	char *sets,dir[50],phrase[100],p_risp[100];
	int i=0;
	sets=malloc(1024);
	memset(sets,0,1024);
	memset(&phrase,0,100);
	memset(&p_risp,0,100);

	sprintf(dir,"./skins/%s",skindir);

	if ((fd=fopen(dir,"r"))<0){
		perror("opening file() ");
		exit(0);
	}

	do { sets[i] = (char)getc(fd);} while ( i < 100 && !feof(fd) && sets[i++] != 0x0a ) ;

	while( !(strstr(sets,"")) || feof(fd) ){
		i=0;
		do { sets[i] = (char)getc(fd);} while ( i < 100 && !feof(fd) && sets[i++] != 0x0a ) ;
		sets[i]='\0';
	}
	strtok(sets,"");
	sets++;
	strncpy(pass,strtok(sets,"\r\n"),100);
	fclose(fd);
	return;
}

int auth(char *login,char *pass){
	FILE *fd;
	char *sets,flogin[100],fpass[100];
	int i=0, ret_val=0;
	sets=malloc(1024);
	memset(sets,0,1024);
	memset(&flogin,0,100);
	memset(&fpass,0,100);

	if( !login || !pass){
		return(0);
	}

	if ((fd=fopen("./conf/users","r"))<0){
		perror("opening file() ");
		exit(0);
	}
	do { sets[i] = (char)getc(fd);} while ( i < 100 && !feof(fd) && sets[i++] != 0x0a );
	while( !(strstr(sets,"@users")) || feof(fd) ){
		i=0;
		do {sets[i] = (char)getc(fd);} while ( i < 100 && !feof(fd) && sets[i++] != 0x0a ) ;
		sets[i]='\0';
	}
	while( !feof(fd) && !(ret_val) ){
		i=0;
		do { sets[i] = (char)getc(fd);} while ( i < 100 && !feof(fd) && sets[i++] != 0x0a ) ;
		sets[i]='\0';
		if (strstr(sets,",")){
			memcpy(flogin,strtok(sets,","),100);
			while(*(sets++)!='\0');
			memcpy(fpass,strtok(sets,"\r\n"),100);
			if(!strcmp(login,flogin) && !strcmp(pass,fpass) ){
        			ret_val=1;
			}
		}
	};
	fclose(fd);
	return(ret_val);
}
void loadchannels(char *skindir,int sockfd){
	FILE *fd;
	char *sets,dir[50],channel[100],ch_cmd[1024];
	int i=0,j=0;
	sets=malloc(1024);
	memset(sets,0,1024);
	memset(&channel,0,100);
	memset(&ch_cmd,0,1024);

	sprintf(dir,"./skins/%s",skindir);

	if ((fd=fopen(dir,"r"))<0){
		perror("opening file() ");
		exit(0);
	}
	do { sets[i] = (char)getc(fd);} while ( i < 100 && !feof(fd) && sets[i++] != 0x0a );
	while( !(strstr(sets,"@channels")) || feof(fd) ){
		i=0;
		do {sets[i] = (char)getc(fd);} while ( i < 100 && !feof(fd) && sets[i++] != 0x0a);
		sets[i]='\0';
	}
	i=0;
	do { sets[i] = (char)getc(fd);} while ( i < 100 && !feof(fd) && sets[i++] != 0x0a ) ;
	sets[i]='\0';
	for(i=0; i<=strlen(sets); i++){
		if((sets[i]==',') || (sets[i]=='\0')){
			j=0;
			i++;
			li_join(sockfd,channel,NULL);
			memset(&channel,0,10);
		}
		channel[j]=sets[i];
		j++;
	}
	fclose(fd);
	return;
}

void loadfile(char *skindir, struct skin *skinopt){
	FILE *fd;
	char *sets,dir[50];
        int i=0;
	struct fields field;
        sets=malloc(1024);
	memset(skinopt,0,80);
	memset(sets,0,1024);

	sprintf(dir,"./skins/%s",skindir);

	if ((fd=fopen(dir,"r"))<0){
		perror("opening file() ");
		exit(0);
	}
	do { sets[i] = (char)getc(fd);} while ( i < 100 && !feof(fd) && sets[i++] != 0x0a ) ;

	while( !(strstr(sets,"@skin")) || feof(fd) ){
		i=0;
		do { sets[i] = (char)getc(fd);} while ( i < 100 && !feof(fd) && sets[i++] != 0x0a );
		sets[i]='\0';
	}

	while(!feof(fd)){
		i=0;
		do { sets[i] = (char)getc(fd);} while ( i < 100 && !feof(fd) && sets[i++] != 0x0a ) ;
		sets[i]='\0';
		if (strstr(sets,"=") && strstr(sets,";")){
			strncpy(field.name,strtok(sets,"="),100);
			while(*(sets++)!='\0');
			strncpy(field.value,strtok(sets,";"),100);
			if (strstr(field.name,"nick"))
				memcpy(skinopt->nick,field.value,10);
			else if (strstr(field.name,"user"))
				memcpy(skinopt->user,field.value,10);
			else if (strstr(field.name,"realname"))
				memcpy(skinopt->realname,field.value,50);
		}
        };
	fclose(fd);
	return;
}

